SoClipPlaneElement Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SoClipPlaneElement Class Reference
Element Classes

The SoClipPlaneElement class is used to manage the clip plane stack. More...

`#include <Inventor/elements/SoClipPlaneElement.h>`

Inheritance diagram for SoClipPlaneElement:

## Public Member Functions
virtual void | init (SoState *state)
virtual void | push (SoState *state)
int | getNum (void) const
const SbPlane & | get (const int index, const SbBool inworldspace=TRUE) const
Public Member Functions inherited from SoAccumulatedElement
virtual SbBool | matches (const SoElement *element) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | add (SoState *const state, SoNode *const node, const SbPlane &plane)
static const SoClipPlaneElement * | getInstance (SoState *const state)
Static Public Member Functions inherited from SoAccumulatedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoClipPlaneElement ()
virtual void | addToElt (const SbPlane &plane, const SbMatrix &modelmatrix)
Protected Member Functions inherited from SoAccumulatedElement
void | clearNodeIds (void)
void | addNodeId (const SoNode *const node)
void | setNodeId (const SoNode *const node)
void | copyNodeIds (const SoAccumulatedElement *copyfrom)
virtual SoElement * | copyMatchInfo (void) const
virtual void | captureThis (SoState *state) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Protected Attributes
SbList< so_plane_data > | planes
int | startIndex
Protected Attributes inherited from SoAccumulatedElement
SbList< uint32_t > | nodeIds
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoClipPlaneElement class is used to manage the clip plane stack.

## Constructor & Destructor Documentation

SoClipPlaneElement::~SoClipPlaneElement | ( |  | ) |
| protectedvirtual

The destructor.

## Member Function Documentation

void * SoClipPlaneElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoClipPlaneElement::init | ( | SoState * | state | ) |
| virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoAccumulatedElement.

Reimplemented in SoGLClipPlaneElement.

void SoClipPlaneElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoAccumulatedElement.

void SoClipPlaneElement::add | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbPlane & | plane
| ) |  |
| static

Adds plane as an active plane. Calls addToElt() to do the job.

const SoClipPlaneElement * SoClipPlaneElement::getInstance | ( | SoState *const | state | ) |
| static

Returns the current (top-of-stack) element.

int SoClipPlaneElement::getNum | ( | void |  | ) | const

Returns the current number of active clipping planes.

const SbPlane & SoClipPlaneElement::get | ( | const int | index,
|  | const SbBool | inworldspace = `TRUE`
| ) |  | const

Returns the 'th plane.

void SoClipPlaneElement::addToElt | ( | const SbPlane & | plane,
|  | const SbMatrix & | modelMatrix
| ) |  |
| protectedvirtual

This method adds the clipping plane, plane, to an instance. modelmatrix is the current model matrix.

Reimplemented in SoGLClipPlaneElement.

## Member Data Documentation

SoClipPlaneElement::planes
| protected

List of currently active planes.

SoClipPlaneElement::startIndex
| protected

Index of first clip plane in this element. Used to disable clip planes in SoGLClipPlaneElement::pop().

The documentation for this class was generated from the following files:

- SoClipPlaneElement.h
- SoClipPlaneElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.